package com.elephant.framework.galaxy.aroad.module.zhjc.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.module.zhjc.entity.ZhjcGhjhCapital;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import com.elephant.framework.galaxy.aroad.module.zhjc.entity.ZhjcGhjh;
import com.elephant.framework.galaxy.aroad.module.zhjc.service.ZhjcGhjhService;
import lombok.AllArgsConstructor;
import org.springframework.boot.web.servlet.ServletComponentScan;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;
import sun.net.www.http.HttpClient;

import java.util.UUID;


/**
 * 智慧决策_规划计划
 *
 * @author wangjian
 * @date 2019-05-27 14:23:44
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhjc/ghjh")
@ServletComponentScan
public class ZhjcGhjhController extends BaseController  {

  private final  ZhjcGhjhService zhjcGhjhService;

  /**
   * 分页查询
   * @param page 分页对象
   * @param zhjcGhjh 智慧决策_规划计划
   * @return
   */
  @GetMapping("/page")
  public R getZhjcGhjhPage(Page page, ZhjcGhjh zhjcGhjh) {
    return  new R<>(zhjcGhjhService.page(page,Wrappers.query(zhjcGhjh)));
  }


  /**
   * 通过id查询智慧决策_规划计划
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") String id){
    return new R<>(zhjcGhjhService.getById(id));
  }

  /**
   * 新增智慧决策_规划计划
   * @return R
   */
  @SysLog("新增智慧决策_规划计划")
  @GetMapping("/add")
  public R save(ZhjcGhjhCapital zhjcGhjhCapital){
    ZhjcGhjh zhjcGhjh = zhjcGhjhService.updateKeyName(zhjcGhjhCapital);
    zhjcGhjh.setId(UUID.randomUUID().toString().replaceAll("-",""));
    return new R<>(zhjcGhjhService.save(zhjcGhjh));
  }

  /**
   * 修改智慧决策_规划计划
   * @return R
   */
  @SysLog("修改智慧决策_规划计划")
  @GetMapping("/update")
  public R updateById(ZhjcGhjhCapital zhjcGhjhCapital){
    ZhjcGhjh zhjcGhjh = zhjcGhjhService.updateKeyName(zhjcGhjhCapital);
    return new R<>(zhjcGhjhService.updateZhjcGhjh(zhjcGhjh));
  }

  /**
   * 通过id删除智慧决策_规划计划
   * @return R
   */
  @SysLog("删除智慧决策_规划计划")
  @GetMapping("/delete")
  public R removeById(String xmid,String xmjd){
    return new R<>(zhjcGhjhService.remove(Wrappers.<ZhjcGhjh>query().lambda().eq(ZhjcGhjh::getXmid,xmid).eq(ZhjcGhjh::getXmjd,xmjd)));
  }
}
